Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/oasis.true
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/oasis.true	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/oasis.true	(revision 633)
@@ -2,5 +2,4 @@
 ! $Header$
 !
-C $Id$
 C****
 C
@@ -20,7 +19,18 @@
 c     INCLUDE "param.h"
 c
-      INTEGER kastp, kexch, kstep,imjm
+      INTEGER kastp, kexch, kstep,imjm,klon
       INTEGER iparal(3)
       INTEGER ifcpl, idt, info, imxtag, istep, jf
+
+c -- LOOP
+c 
+#include "dimensions.h"
+      INTEGER jjmp1
+      PARAMETER (jjmp1=jjm+1-1/jjm)
+#include "dimphy.h"
+c      REAL zu10m(klon), zv10m(klon)
+       REAL zwindsp(klon)
+c
+c -- LOOP
 c
 #include "param_cou.h"
@@ -43,5 +53,6 @@
 #include "mpiclim.h"
 c
-#include "oasis.h"      ! contains the name of communication technique. Here
+#include "oasis.h"      
+                        ! contains the name of communication technique. Here
                         ! cchan=CLIM only is possible.
 c			! ctype=MPI2
@@ -71,27 +82,30 @@
 c         must be the same as (1) of the field  definition in namcouple:
 c
-      cl_writ(1)='COSHFICE'
-      cl_writ(2)='COSHFOCE'
-      cl_writ(3)='CONSFICE'
-      cl_writ(4)='CONSFOCE'
-      cl_writ(5)='CODFLXDT'
+      cl_writ(8)='COSHFICE'
+      cl_writ(9)='COSHFOCE'
+      cl_writ(10)='CONSFICE'
+      cl_writ(11)='CONSFOCE'
+      cl_writ(12)='CODFLXDT'
 c      cl_writ(6)='COICTEMP'
-      cl_writ(6)='COTFSICE'
-      cl_writ(7)='COTFSOCE'
-      cl_writ(8)='COTOLPSU'
-      cl_writ(9)='COTOSPSU'
-      cl_writ(10)='CORUNCOA'
-      cl_writ(11)='CORIVFLU'
-      cl_writ(12)='COCALVIN'
+      cl_writ(13)='COTFSICE'
+      cl_writ(14)='COTFSOCE'
+      cl_writ(15)='COTOLPSU'
+      cl_writ(16)='COTOSPSU'
+      cl_writ(17)='CORUNCOA'
+      cl_writ(18)='CORIVFLU'
+      cl_writ(19)='COCALVIN'
 c$$$      cl_writ(13)='COZOTAUX'
 c$$$      cl_writ(14)='COZOTAUV'
 c$$$      cl_writ(15)='COMETAUY'
 c$$$      cl_writ(16)='COMETAUU'
-      cl_writ(13)='COTAUXXU'
-      cl_writ(14)='COTAUYYU'
-      cl_writ(15)='COTAUZZU'
-      cl_writ(16)='COTAUXXV'
-      cl_writ(17)='COTAUYYV'
-      cl_writ(18)='COTAUZZV'
+      cl_writ(1)='COTAUXXU'
+      cl_writ(2)='COTAUYYU'
+      cl_writ(3)='COTAUZZU'
+      cl_writ(4)='COTAUXXV'
+      cl_writ(5)='COTAUYYV'
+      cl_writ(6)='COTAUZZV'
+c -- LOOP
+      cl_writ(7)='COWINDSP'
+c -- LOOP
 c
 c     Define files name for fields exchanged from atmos to coupler,
@@ -116,4 +130,7 @@
       cl_f_writ(17)='flxatmos'
       cl_f_writ(18)='flxatmos'
+c -- LOOP
+      cl_f_writ(19)='flxatmos'
+c -- LOOP
 
 c
@@ -311,6 +328,8 @@
       SUBROUTINE intocpl(kt, imjm, fsolice, fsolwat, fnsolice, fnsolwat,
      $    fnsicedt, evice, evwat, lpre, spre, dirunoff, rivrunoff, 
-     $    calving, tauxx_u, tauyy_u, tauzz_u, tauxx_v, tauyy_v, tauzz_v
-     $    , last) 
+     $    calving, tauxx_u, tauyy_u, tauzz_u, tauxx_v, tauyy_v, tauzz_v,
+c -- LOOP
+     $    windsp, last)
+c -- LOOP 
 c ======================================================================
 c S. Valcke (02/99) adapted From L.Z.X Li: this subroutine provides the 
@@ -320,4 +339,16 @@
 c ======================================================================
       IMPLICIT NONE
+c -- LOOP
+c 
+#include "dimensions.h"
+      INTEGER jjmp1
+      PARAMETER (jjmp1=jjm+1-1/jjm)
+#include "dimphy.h"
+c      REAL zu10m(klon), zv10m(klon)
+       REAL zwindsp(klon)
+c
+c -- LOOP
+c
+
       INTEGER kt, imjm
 c
@@ -344,4 +375,7 @@
       REAL tauzz_u(imjm)
       REAL tauzz_v(imjm)
+c -- LOOP
+       REAL windsp(imjm)
+c -- LOOP
       LOGICAL last
 c
@@ -423,41 +457,41 @@
 c         WRITE fields to files          
           DO jf=1, jpflda2o1 + jpflda2o2
-            IF (jf.eq.1)
+            IF (jf.eq.8)
      $          CALL locwrite(cl_writ(jf),fsolice, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.2)
+            IF (jf.eq.9)
      $          CALL locwrite(cl_writ(jf),fsolwat, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.3)
+            IF (jf.eq.10)
      $          CALL locwrite(cl_writ(jf),fnsolice, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.4)
+            IF (jf.eq.11)
      $          CALL locwrite(cl_writ(jf),fnsolwat, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.5)
+            IF (jf.eq.12)
      $          CALL locwrite(cl_writ(jf),fnsicedt, imjm,
      $          file_unit_field(jf), ierror) 
-c            IF (jf.eq.6)
+c            IF (jf.eq.13)
 c     $          CALL locwrite(cl_writ(jf),ictemp, imjm,
 c     $          file_unit_field(jf), ierror) 
-            IF (jf.eq.6)
+            IF (jf.eq.13)
      $          CALL locwrite(cl_writ(jf),evice, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.7)
+            IF (jf.eq.14)
      $          CALL locwrite(cl_writ(jf),evwat, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.8)
+            IF (jf.eq.15)
      $          CALL locwrite(cl_writ(jf),lpre, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.9)
+            IF (jf.eq.16)
      $          CALL locwrite(cl_writ(jf),spre, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.10)
+            IF (jf.eq.17)
      $          CALL locwrite(cl_writ(jf),dirunoff, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.11)
+            IF (jf.eq.18)
      $          CALL locwrite(cl_writ(jf),rivrunoff, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.12)
+            IF (jf.eq.19)
      $          CALL locwrite(cl_writ(jf),calving, imjm,
      $          file_unit_field(jf), ierror) 
@@ -474,22 +508,28 @@
 c$$$     $          CALL locwrite(cl_writ(jf),tauyu, imjm,
 c$$$     $          file_unit_field(jf), ierror) 
-            IF (jf.eq.13)
+            IF (jf.eq.1)
      $          CALL locwrite(cl_writ(jf),tauxx_u, imjm,
      $          file_unit_field(jf),ierror)
-            IF (jf.eq.14)
+            IF (jf.eq.2)
      $          CALL locwrite(cl_writ(jf),tauyy_u, imjm,
      $          file_unit_field(jf),ierror)
-            IF (jf.eq.15)
+            IF (jf.eq.3)
      $          CALL locwrite(cl_writ(jf),tauzz_u, imjm,
      $          file_unit_field(jf),ierror)
-            IF (jf.eq.16)
+            IF (jf.eq.4)
      $          CALL locwrite(cl_writ(jf),tauxx_v, imjm,
      $          file_unit_field(jf),ierror)
-            IF (jf.eq.17)
+            IF (jf.eq.5)
      $          CALL locwrite(cl_writ(jf),tauyy_v, imjm,
      $          file_unit_field(jf),ierror)
-            IF (jf.eq.18)
+            IF (jf.eq.6)
      $          CALL locwrite(cl_writ(jf),tauzz_v, imjm,
      $          file_unit_field(jf),ierror)
+c -- LOOP
+            IF (jf.eq.7)
+     $          CALL locwrite(cl_writ(jf),windsp, imjm,
+     $         file_unit_field(jf),ierror)
+c -- LOOP
+
           END DO 
 C
@@ -521,28 +561,30 @@
           DO jn=1, jpflda2o1 + jpflda2o2
 C            
-          IF (jn.eq.1) CALL CLIM_Export(cl_writ(jn), kt, fsolice, info)
-          IF (jn.eq.2) CALL CLIM_Export(cl_writ(jn), kt, fsolwat, info)
-          IF (jn.eq.3) CALL CLIM_Export(cl_writ(jn), kt, fnsolice, info)
-          IF (jn.eq.4) CALL CLIM_Export(cl_writ(jn), kt, fnsolwat, info)
-          IF (jn.eq.5) CALL CLIM_Export(cl_writ(jn), kt, fnsicedt, info)
+          IF (jn.eq.8) CALL CLIM_Export(cl_writ(jn), kt, fsolice, info)
+          IF (jn.eq.9) CALL CLIM_Export(cl_writ(jn), kt, fsolwat, info)
+         IF (jn.eq.10) CALL CLIM_Export(cl_writ(jn), kt, fnsolice, info)
+         IF (jn.eq.11) CALL CLIM_Export(cl_writ(jn), kt, fnsolwat, info)
+         IF (jn.eq.12) CALL CLIM_Export(cl_writ(jn), kt, fnsicedt, info)
 c          IF (jn.eq.6) CALL CLIM_Export(cl_writ(jn), kt, ictemp, info)
-          IF (jn.eq.6) CALL CLIM_Export(cl_writ(jn), kt, evice, info)
-          IF (jn.eq.7) CALL CLIM_Export(cl_writ(jn), kt, evwat, info)
-          IF (jn.eq.8) CALL CLIM_Export(cl_writ(jn), kt, lpre, info)
-          IF (jn.eq.9) CALL CLIM_Export(cl_writ(jn), kt, spre, info)
-          IF (jn.eq.10) CALL CLIM_Export(cl_writ(jn),kt,dirunoff, info)
-          IF (jn.eq.11) CALL CLIM_Export(cl_writ(jn),kt,rivrunoff,info)
-          IF (jn.eq.12) CALL CLIM_Export(cl_writ(jn),kt,calving,info)
+          IF (jn.eq.13) CALL CLIM_Export(cl_writ(jn), kt, evice, info)
+          IF (jn.eq.14) CALL CLIM_Export(cl_writ(jn), kt, evwat, info)
+          IF (jn.eq.15) CALL CLIM_Export(cl_writ(jn), kt, lpre, info)
+          IF (jn.eq.16) CALL CLIM_Export(cl_writ(jn), kt, spre, info)
+          IF (jn.eq.17) CALL CLIM_Export(cl_writ(jn),kt,dirunoff, info)
+          IF (jn.eq.18) CALL CLIM_Export(cl_writ(jn),kt,rivrunoff,info)
+          IF (jn.eq.19) CALL CLIM_Export(cl_writ(jn),kt,calving,info)
 c$$$          IF (jn.eq.13) CALL CLIM_Export(cl_writ(jn), kt, tauxu, info)
 c$$$          IF (jn.eq.14) CALL CLIM_Export(cl_writ(jn), kt, tauxv, info)
 c$$$          IF (jn.eq.15) CALL CLIM_Export(cl_writ(jn), kt, tauyv, info)
 c$$$          IF (jn.eq.16) CALL CLIM_Export(cl_writ(jn), kt, tauyu, info)
-          IF (jn.eq.13) CALL CLIM_Export(cl_writ(jn), kt, tauxx_u, info)
-          IF (jn.eq.14) CALL CLIM_Export(cl_writ(jn), kt, tauyy_u, info)
-          IF (jn.eq.15) CALL CLIM_Export(cl_writ(jn), kt, tauzz_u, info)
-          IF (jn.eq.16) CALL CLIM_Export(cl_writ(jn), kt, tauxx_v, info)
-          IF (jn.eq.17) CALL CLIM_Export(cl_writ(jn), kt, tauyy_v, info)
-          IF (jn.eq.18) CALL CLIM_Export(cl_writ(jn), kt, tauzz_v, info)
-          
+          IF (jn.eq.1) CALL CLIM_Export(cl_writ(jn), kt, tauxx_u, info)
+          IF (jn.eq.2) CALL CLIM_Export(cl_writ(jn), kt, tauyy_u, info)
+          IF (jn.eq.3) CALL CLIM_Export(cl_writ(jn), kt, tauzz_u, info)
+          IF (jn.eq.4) CALL CLIM_Export(cl_writ(jn), kt, tauxx_v, info)
+          IF (jn.eq.5) CALL CLIM_Export(cl_writ(jn), kt, tauyy_v, info)
+          IF (jn.eq.6) CALL CLIM_Export(cl_writ(jn), kt, tauzz_v, info)
+c -- LOOP
+          IF (jn.eq.7) CALL CLIM_Export(cl_writ(jn), kt, windsp, info)
+c -- LOOP          
             IF (info .NE. CLIM_Ok) THEN
                 WRITE (nuout,*) 'STEP : Pb giving ',cl_writ(jn), ':',jn
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/orografi.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/orografi.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/orografi.F	(revision 633)
@@ -1277,5 +1277,6 @@
            ZDELPT=PAPHM1(JL,NSTRA)-PAPHM1(JL,KKCRITH(JL))
            PTAU(JL,JK)=ZTAU(JL,KKCRITH(JL)) +
-     *                 (ZTAU(JL,NSTRA)-ZTAU(JL,KKCRITH(JL)))*ZDELP/ZDELPT
+     *                 (ZTAU(JL,NSTRA)-ZTAU(JL,KKCRITH(JL)))*ZDELP
+     .                                                     /ZDELPT
 
        ENDIF
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/param_cou.h
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/param_cou.h	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/param_cou.h	(revision 633)
@@ -9,7 +9,9 @@
 	PARAMETER(jpmaxfld = 40)        ! Maximum number of fields exchanged
                                         ! between ocean and atmosphere
+! -- LOOP
 	INTEGER jpflda2o1
-	PARAMETER(jpflda2o1 = 12)         ! Number of fields exchanged from
+	PARAMETER(jpflda2o1 = 13)        ! Number of fields exchanged from
                                          ! atmosphere to ocean via flx.F
+! -- LOOP
 	INTEGER jpflda2o2
 	PARAMETER(jpflda2o2 = 6)         ! Number of fields exchanged from
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phyetat0.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/phyetat0.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phyetat0.F	(revision 633)
@@ -665,31 +665,4 @@
            ENDDO
          ENDDO
-c          IF (nsrf.GT.99) THEN
-c            PRINT*, "Trop de sous-mailles"
-c            CALL abort
-c          ENDIF
-c          WRITE(str2,'(i2.2)') nsrf
-c          ierr = NF_INQ_VARID (nid, "ALBLW"//str2, nvarid)
-c           IF (ierr.NE.NF_NOERR) THEN
-c             PRINT*, "phyetat0: Le champ <ALBLW"//str2//"> est absent"
-c             CALL abort
-c          ENDIF
-c#ifdef NC_DOUBLE
-c           ierr = NF_GET_VAR_DOUBLE(nid, nvarid, alblw(1,nsrf))
-c#else
-c           ierr = NF_GET_VAR_REAL(nid, nvarid, alblw(1,nsrf))
-c#endif
-c          IF (ierr.NE.NF_NOERR) THEN
-c            PRINT*, "phyetat0: Lecture echouee pour <ALBLW"//str2//">"
-c            CALL abort
-c          ENDIF
-c          xmin = 1.0E+20
-c          xmax = -1.0E+20
-c          DO i = 1, klon
-c             xmin = MIN(alblw(i,nsrf),xmin)
-c             xmax = MAX(alblw(i,nsrf),xmax)
-c          ENDDO
-c          PRINT*,'Albedo du sol ALBLW**:', nsrf, xmin, xmax
-c        ENDDO
       ELSE
          PRINT*, 'phyetat0: Le champ <ALBLW> est present'
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phyredem.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/phyredem.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phyredem.F	(revision 633)
@@ -3,5 +3,4 @@
 !
 c
-cIM   SUBROUTINE phyredem (fichnom,dtime,radpas,co2_ppm,solaire,
       SUBROUTINE phyredem (fichnom,dtime,radpas,
      .           rlat,rlon, pctsrf,tsol,tsoil,deltat,qsurf,qsol,snow,
@@ -30,6 +29,4 @@
       INTEGER radpas
       REAL rlat(klon), rlon(klon)
-cIM   REAL co2_ppm
-cIM   REAL solaire
       REAL tsol(klon,nbsrf)
       REAL tsoil(klon,nsoilmx,nbsrf)
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/physiq.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/physiq.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/physiq.F	(revision 633)
@@ -2,6 +2,4 @@
 ! $Header$
 !
-C
-c $Header$
 c
       SUBROUTINE physiq (nlon,nlev,nqmax,
@@ -10,5 +8,5 @@
      .            u,v,t,qx,
      .            omega,
-#ifdef INCA_CH4
+#ifdef INCA
      .            flxmass_w,
 #endif
@@ -19,4 +17,5 @@
 #ifdef INCA
       USE chemshut
+      USE species_names
 #ifdef INCA_CH4
 !      USE obs_pos
@@ -36,11 +35,11 @@
 c   CLEFS CPP POUR LES IO
 c   =====================
-c #define histhf
+#define histhf
 #define histday
 #define histmth
 #define histins
-c #define histISCCP
-c #define histREGDYN
-c #define histmthNMC
+c#define histISCCP
+#define histREGDYN
+#define histmthNMC
 c======================================================================
 c    modif   ( P. Le Van ,  12/10/98 )
@@ -84,8 +83,10 @@
 #include "clesphys.h"
 #include "control.h"
+#include "logic.h"
 #include "temps.h"
 #include "comgeomphy.h"
 #include "advtrac.h"
 #include "iniprint.h"
+#include "thermcell.h"
 c======================================================================
       LOGICAL ok_cvl  ! pour activer le nouveau driver pour convection KE
@@ -157,4 +158,10 @@
       PARAMETER (ok_region=.FALSE.)
 c======================================================================
+c     pour phsystoke avec thermiques
+      REAL fm_therm(klon,klev+1)
+      REAL entr_therm(klon,klev)
+      real q2(klon,klev+1,nbsrf)
+      save q2
+c======================================================================
 c
       INTEGER ivap          ! indice de traceurs pour vapeur d'eau
@@ -197,5 +204,5 @@
       REAL omega(klon,klev)
 
-#ifdef INCA_CH4
+#ifdef INCA
       REAL flxmass_w(klon,klev)
 #endif
@@ -205,4 +212,5 @@
       REAL d_qx(klon,klev,nqmax)
       REAL d_ps(klon)
+      real da(klon,klev),phi(klon,klev,klev),mp(klon,klev)
 
       INTEGER klevp1, klevm1
@@ -368,5 +376,4 @@
       SAVE nhistoWt
 
-      INTEGER linv
       INTEGER pct_ocean(klon,nbregdyn)
       REAL rlonPOS(klon) 
@@ -594,7 +601,7 @@
       REAL zxffonte(klon), zxfqcalving(klon)
 
-      LOGICAL offline           ! Controle du stockage ds "physique"
-      PARAMETER (offline=.false.)
-      INTEGER physid
+c$$$      LOGICAL offline           ! Controle du stockage ds "physique"
+c$$$      PARAMETER (offline=.false.)
+c$$$      INTEGER physid
       REAL pfrac_impa(klon,klev)! Produits des coefs lessivage impaction
       save pfrac_impa
@@ -606,4 +613,5 @@
       REAL frac_nucl(klon,klev) ! idem (nucleation)
 #ifdef INCA
+      INTEGER       :: iii
       REAL          :: calday
 #endif
@@ -620,4 +628,7 @@
       REAL sens(klon), dsens(klon) ! chaleur sensible et sa derivee
       REAL dlw(klon)    ! derivee infra rouge
+cym
+      SAVE dlw
+cym
       REAL bils(klon) ! bilan de chaleur au sol
       REAL wfbils(klon,nbsrf) ! bilan de chaleur au sol, pour chaque
@@ -759,5 +770,5 @@
       REAL zx_t, zx_qs, zdelta, zcor, zfra, zlvdcp, zlsdcp
       real zqsat(klon,klev)
-      INTEGER i, k, iq, ig, j, nsrf, ll
+      INTEGER i, k, iq, ig, j, iiq, nsrf, ll
       REAL t_coup
       PARAMETER (t_coup=234.0)
@@ -785,5 +796,5 @@
       INTEGER iflagctrl(klon)          ! flag fonctionnement de convect
 c -- convect43:
-      INTEGER ntra              ! nb traceurs pour convect4.3
+      INTEGER ntra              ! nb traceurs 
       REAL pori_con(klon)    ! pressure at the origin level of lifted parcel
       REAL plcl_con(klon),dtma_con(klon),dtlcl_con(klon)
@@ -807,4 +818,5 @@
       REAL d_t_lsc(klon,klev),d_q_lsc(klon,klev),d_ql_lsc(klon,klev)
       REAL d_t_ajs(klon,klev), d_q_ajs(klon,klev)
+      REAL d_u_ajs(klon,klev), d_v_ajs(klon,klev)
       REAL d_t_eva(klon,klev),d_q_eva(klon,klev)
       REAL rneb(klon,klev)
@@ -818,4 +830,7 @@
 c
       INTEGER ibas_con(klon), itop_con(klon)
+cym
+      SAVE ibas_con,itop_con
+cym
       REAL rain_con(klon), rain_lsc(klon)
       REAL snow_con(klon), snow_lsc(klon)
@@ -968,4 +983,7 @@
       LOGICAL ok_ade, ok_aie    ! Apply aerosol (in)direct effects or not
       REAL bl95_b0, bl95_b1   ! Parameter in Boucher and Lohmann (1995)
+cym 
+      SAVE ok_ade, ok_aie, bl95_b0, bl95_b1
+cym
 cjq-end
 c
@@ -976,4 +994,38 @@
 #include "FCTTRE.h"
 c======================================================================
+!rv
+      u10m(:,:)=0.
+      v10m(:,:)=0.
+      t2m(:,:)=0.
+      q2m(:,:)=0.
+      ffonte(:,:)=0.
+      fqcalving(:,:)=0.
+      piz_ae(:,:,:)=0.
+      tau_ae(:,:,:)=0.
+      cg_ae(:,:,:)=0.
+      rain_con(:)=0.
+      snow_con(:)=0.
+      bl95_b0=0.
+      bl95_b1=0.
+      topswai(:)=0.
+      topswad(:)=0.
+      solswai(:)=0.
+      solswad(:)=0.
+!rv
+! anne
+      d_u_con(:,:) = 0.0
+      d_v_con(:,:) = 0.0
+      rnebcon0(:,:) = 0.0
+      clwcon0(:,:) = 0.0
+      rnebcon(:,:) = 0.0
+      clwcon(:,:) = 0.0
+      paire_ter(:) = 0.0
+      nhistoW(:,:,:,:) = 0.0
+      histoW(:,:,:,:) = 0.0
+! fin anne
+
+cym
+      wfbils(:,:)=0
+cym      
       modname = 'physiq'
       IF (if_ebil.ge.1) THEN
@@ -998,5 +1050,5 @@
 c======================================================================
 cIM BEG
-        DO k=1, nlev
+        DO k=1, nlevENS
           DO l=1, nlevSTD
 c
@@ -1034,6 +1086,6 @@
      .                  iflag_cldcon,ratqsbas,ratqshaut, if_ebil,
      .                  ok_ade, ok_aie, 
-     .                  bl95_b0, bl95_b1)
-cIM  .                  , RI0)
+     .                  bl95_b0, bl95_b1,
+     .                  iflag_thermals,nsplit_thermals)
 
 c
@@ -1053,4 +1105,6 @@
      .       run_off_lic_0)
 
+c   ATTENTION : il faudra a terme relire q2 dans l'etat initial
+         q2(:,:,:)=1.e-8
 c
          radpas = NINT( 86400./dtime/nbapp_rad)
@@ -1100,8 +1154,4 @@
 
          WRITE(lunout,*)"*** Convection de Kerry Emanuel 4.3  "
-         WRITE(lunout,*)
-     .      "On va utiliser le melange convectif des traceurs qui"
-         WRITE(lunout,*)"est calcule dans convect4.3"
-         WRITE(lunout,*)" !!! penser aux logical flags de phytrac"
 
           DO i = 1, klon
@@ -1114,5 +1164,5 @@
           DO i = 1, klon
            ibas_con(i) = 1
-           itop_con(i) = klev+1
+           itop_con(i) = 1
           ENDDO
 cIM15/11/02 rajout initialisation ibas_con,itop_con cf. SB =>END
@@ -1256,13 +1306,8 @@
      $                   presnivs,
      $                   calday,
-     $                   tracnam,
-     $                   natsnam,
-c     $                   mxoutflds,
-c     $                   outinst,
-c     $                   outtimav,
      $                   klon,
      $                   nqmax,
      $                   pdtphys,
-     $                   anne_ref,
+     $                   annee_ref,
      $                   day_ini)
 #ifdef INCAINFO
@@ -1508,4 +1553,5 @@
      s            d_t_vdf,d_q_vdf,d_u_vdf,d_v_vdf,d_ts,
      s            fluxt,fluxq,fluxu,fluxv,cdragh,cdragm,
+     s            q2,
      s            dsens, devap,
      s            ycoefh,yu1,yv1, t2m, q2m, u10m, v10m,
@@ -1684,10 +1730,8 @@
       ELSE IF (iflag_con.GE.3) THEN
 c nb of tracers for the KE convection:
-          if (nqmax .GE. 4) then
-              ntra = nbtr
-          else
-              ntra = 1 
-          endif
-c
+c MAF la partie traceurs est faite dans phytrac
+c on met ntra=1 pour limiter les appels mais on peut
+c supprimer les calculs / ftra.
+              ntra = 1
 c sb, oct02:
 c Schema de convection modularise et vectorise:
@@ -1698,5 +1742,5 @@
           CALL concvl (iflag_con,
      .        dtime,paprs,pplay,t_seri,q_seri,
-     .        u_seri,v_seri,tr_seri,nbtr,
+     .        u_seri,v_seri,tr_seri,ntra,
      .        ema_work1,ema_work2,
      .        d_t_con,d_q_con,d_u_con,d_v_con,d_tr,
@@ -1704,13 +1748,17 @@
      .        upwd,dnwd,dnwd0,
      .        Ma,cape,tvp,iflagctrl,
-     .        pbase,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr,qcondc,wd)
+     .        pbase,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr,qcondc,wd,
+     .        pmflxr,pmflxs,
+     .        da,phi,mp)
+
 cIM cf. FH
               clwcon0=qcondc
+              pmfu(:,:)=upwd(:,:)+dnwd(:,:)
 
           ELSE ! ok_cvl
-
+c MAF conema3 ne contient pas les traceurs
           CALL conema3 (dtime,
      .        paprs,pplay,t_seri,q_seri,
-     .        u_seri,v_seri,tr_seri,nbtr,
+     .        u_seri,v_seri,tr_seri,ntra,
      .        ema_work1,ema_work2,
      .        d_t_con,d_q_con,d_u_con,d_v_con,d_tr,
@@ -1836,25 +1884,43 @@
       zx_ajustq=.FALSE.
 c
-      IF (nqmax.GT.2) THEN !--melange convectif de traceurs
-c
-          IF (iflag_con .NE. 2 .AND. debut) THEN 
-              WRITE(lunout,*)'Pour l instant, seul conflx fonctionne ',
-     $            'avec traceurs', iflag_con
-              WRITE(lunout,*)' Mettre iflag_con', 
-     $            ' = 2 dans run.def et repasser'
-c              CALL abort
-              ENDIF 
-c
-      ENDIF !--nqmax.GT.2
-c
-c Appeler l'ajustement sec
-c
-      CALL ajsec(paprs, pplay, t_seri, q_seri, d_t_ajs, d_q_ajs)
-      DO k = 1, klev
-      DO i = 1, klon
-         t_seri(i,k) = t_seri(i,k) + d_t_ajs(i,k)
-         q_seri(i,k) = q_seri(i,k) + d_q_ajs(i,k)
-      ENDDO
-      ENDDO
+c===================================================================
+c Convection seche (thermiques ou ajustement)
+c===================================================================
+c
+      d_t_ajs(:,:)=0.
+      d_u_ajs(:,:)=0.
+      d_v_ajs(:,:)=0.
+      d_q_ajs(:,:)=0.
+      fm_therm(:,:)=0.
+      entr_therm(:,:)=0.
+c
+      IF(prt_level>9)WRITE(lunout,*)
+     .    'AVANT LA CONVECTION SECHE , iflag_thermals='
+     s   ,iflag_thermals,'   nsplit_thermals=',nsplit_thermals
+      if(iflag_thermals.lt.0) then
+c  Rien
+c  ====
+         IF(prt_level>9)WRITE(lunout,*)'pas de convection'
+      else if(iflag_thermals.eq.0) then
+
+c  Ajustement sec
+c  ==============
+         IF(prt_level>9)WRITE(lunout,*)'ajsec'
+         CALL ajsec(paprs, pplay, t_seri,q_seri, d_t_ajs, d_q_ajs)
+         t_seri(:,:) = t_seri(:,:) + d_t_ajs(:,:)
+         q_seri(:,:) = q_seri(:,:) + d_q_ajs(:,:)
+      else
+c  Thermiques
+c  ==========
+         IF(prt_level>9)WRITE(lunout,*)'JUSTE AVANT , iflag_thermals='
+     s   ,iflag_thermals,'   nsplit_thermals=',nsplit_thermals
+         call calltherm(pdtphys
+     s      ,pplay,paprs,pphi
+     s      ,u_seri,v_seri,t_seri,q_seri
+     s      ,d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs
+     s      ,fm_therm,entr_therm)
+      endif
+c
+c===================================================================
 c
       IF (if_ebil.ge.2) THEN 
@@ -2305,4 +2371,10 @@
          CALL aeropt(pplay, paprs, t_seri, sulfate, rhcl,
      .        tau_ae, piz_ae, cg_ae, aerindex)
+cym
+      ELSE
+        tau_ae(:,:,:)=0.0
+	piz_ae(:,:,:)=0.0
+	cg_ae(:,:,:)=0.0
+cym     
       ENDIF
 
@@ -2312,5 +2384,5 @@
 #ifdef INCA_AER
       call AEROSOL_METEO_CALC(calday,pdtphys,pplay,paprs,t,pmflxr,pmflxs,
-     &   prfl,psfl,pctsrf,airephy,xjour,rlat,rlon)
+     &   prfl,psfl,pctsrf(1,3),airephy,xjour,rlat,rlon)
 #endif
 
@@ -2318,6 +2390,7 @@
            WRITE(lunout,*)'Appel CHEMHOOK_BEGIN ...'
 #endif
+
            CALL chemhook_begin (calday,
-     $                          pctsrf(1,3),
+     $                          pctsrf(1,1),
      $                          rlat,
      $                          rlon,
@@ -2343,5 +2416,18 @@
      $                          iim,
      $                          jjm,
-     $                          tr_seri)
+#ifdef INCA_AER
+     $                          tr_seri,
+     $                          ftsol,
+     $                          paprs,
+     $                          cdragh,
+     $                          cdragm,
+     $                          pctsrf,
+     $				pdtphys,
+     $				itap)
+#else
+     $                          tr_seri)     
+#endif        
+
+
 #ifdef INCAINFO
            WRITE(lunout,*)'OK.'
@@ -2545,51 +2631,71 @@
 c   Calcul  des tendances traceurs
 c====================================================================
-C Pascale : il faut quand meme apeller phytrac car il gere les sorties
-cKE43       des traceurs => il faut donc mettre des flags a .false.
-      IF (iflag_con.GE.3) THEN
-c           on ajoute les tendances calculees par KE43
-cXXX OM on onhibe la convection sur les traceurs
-        DO iq=1, nqmax-2 ! Sandrine a -3 ???
-cXXX OM on inhibe la convection sur les traceur
-cXXX        DO k = 1, nlev
-cXXX        DO i = 1, klon
-cXXX          tr_seri(i,k,iq) = tr_seri(i,k,iq) + d_tr(i,k,iq)
-cXXX        ENDDO
-cXXX        ENDDO
-        WRITE(iqn,'(i2.2)') iq
-        CALL minmaxqfi(tr_seri(1,1,iq),0.,1.e33,'couche lim iq='//iqn)
-        ENDDO
-CMAF modif pour garder info du nombre de traceurs auxquels
-C la physique s'applique
-      ELSE
-CMAF modif pour garder info du nombre de traceurs auxquels
-C la physique s'applique
 C
-      call phytrac (rnpb,
-     I                   itap, julien, gmtime,
-     I                   debut,lafin,
+      call phytrac (iflag_con,
+     I                   rnpb,
+     I                   itap, 
+     I                   julien, 
+     I                   gmtime,
+     I                   debut,
+     I                   lafin,
      I                   nqmax-2,
-     I                   nlon,nlev,dtime,
-     I                   u,v,t,paprs,pplay,
-     I                   pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
-     I                   ycoefh,yu1,yv1,ftsol,pctsrf,rlat,
-     I                   frac_impa, frac_nucl,
-     I                   rlon,presnivs,pphis,pphi,
+     I                   nlon,
+     I                   nlev,
+     I                   dtime,
+     I                   u,
+     I                   v,
+     I                   t,
+     I                   paprs,
+     I                   pplay,
+     I                   pmfu, 
+     I                   pmfd, 
+     I                   pen_u, 
+     I                   pde_u, 
+     I                   pen_d, 
+     I                   pde_d,
+     I                   ycoefh,
+     I                   fm_therm,
+     I                   entr_therm,
+     I                   yu1,
+     I                   yv1,
+     I                   ftsol,
+     I                   pctsrf,
+     I                   rlat,
+     I                   frac_impa, 
+     I                   frac_nucl,
+     I                   rlon,
+     I                   presnivs,
+     I                   pphis,
+     I                   pphi,
      I                   albsol,
-     I                   qx(1,1,1), rhcl,
-     I                   cldfra, rneb, diafra, cldliq, itop_con,
+     I                   qx(1,1,1), 
+     I                   rhcl,
+     I                   cldfra, 
+     I                   rneb, 
+     I                   diafra, 
+     I                   cldliq, 
+     I                   itop_con,
      I                   ibas_con,
-     I                   pmflxr,pmflxs,prfl,psfl,
-#ifdef INCA_CH4
+     I                   pmflxr,
+     I                   pmflxs,
+     I                   prfl,
+     I                   psfl,
+     I                   da,
+     I                   phi,
+     I                   mp,
+     I                   upwd,
+     I                   dnwd,
+#ifdef INCA
      I                   flxmass_w,
 #endif
      O                   tr_seri)
-      ENDIF 
 
       IF (offline) THEN
 
+         print*,'Attention on met a 0 les thermiques pour phystoke'
 	 call phystokenc (
      I                   nlon,nlev,pdtphys,rlon,rlat,
      I                   t,pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
+     I                   fm_therm,entr_therm,
      I                   ycoefh,yu1,yv1,ftsol,pctsrf,
      I                   frac_impa, frac_nucl,
@@ -2822,8 +2928,18 @@
      $                        nbtr,
      $                        paprs,
+#ifdef INCA_CH4
      $                        q_seri,
-     $                        anne_ini,
+#endif
+     $                        annee_ref,
      $                        day_ini,
+#ifdef INCA_AER
+     $                        xjour,
+     $                        pphi,
+     $                        pphis,
+     $                        zx_rh,
+     $                        qx(1,1,1))
+#else
      $                        xjour)
+#endif
 #ifdef INCAINFO
            WRITE(lunout,*)'OK.'
